/*
 *	rs2item.h
 *		Copyright (C)2002, 2003 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#ifndef RS2ITEM_H
#define RS2ITEM_H

#include "rs2define.h"

typedef struct weapon_tag
{
	int attack_power;	/* U */
	int weight;			/* d */
	int tech_no[2];		/* ŗLZ̔ԍ */
} weapon_t;

typedef struct protector_tag
{
	int defense_slash;			/* aU̖h */
	int defense_knock;			/* U̖h */
	int defense_poke;			/* ˍU̖h */
	int defense_shoot;			/* ˍU̖h */
	int defense_fire;			/* MU̖h */
	int defense_ice;			/* CU̖h */
	int defense_thunder;		/* U̖h */
	int defense_state;			/* ԕωU̖h */
	int increase_strength;		/* r͏㏸ */
	int increase_dexterity;		/* p㏸ */
	int increase_magic_power;	/* ͏㏸ */
	int increase_unknown;		/* s㏸ */
	int increase_speed;			/* f㏸ */
	int increase_stamina;		/* ̗͏㏸ */
	int weight;					/* d */
	state_t regist_state;		/* ԕωւ̑ϐ */
} protector_t;

typedef struct shield_tag
{
	int defense_power;	/* h */
	int evade_rate;		/*  */
	int weight;			/* d */
	elem_t regist_elem;	/* h䑮 */
} shield_t;

union itemparam_t
{
	weapon_t weapon;		/* ACef[^ */
	protector_t protector;	/* hACef[^ */
	shield_t shield;		/* f[^ */
};

typedef struct itemdata_tag
{
	int type;					/* ^Cv(ITEM_TYPE_WEAPON`ITEM_TYPE_OTHER) */
	int power;					/* \̍U/h */
	long price;					/* i */
	int message_no;				/* bZ[W̔ԍ */
	union itemparam_t param;	/* ACef[^ */
} itemdata_t;

enum	/* itemdata_t.typep */
{
	ITEM_TYPE_WEAPON,		/*  */
	ITEM_TYPE_PROTECTOR,	/* h */
	ITEM_TYPE_SHIELD,		/*  */
	ITEM_TYPE_OTHER,		/* ̑ */
	ITEM_TYPE_NUM
};

const char *item_getname(int index);
itemdata_t *item_readdata(void);
int item_writeparam(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeregist(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeeffect(const char *ptr_filename, const itemdata_t *ptr_itemdata);

#endif /* RS2ITEM_H */
