/*
 *	rs2monster.h
 *		Copyright (C)2002-2004 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#ifndef RS2MONSTER_H
#define RS2MONSTER_H

#include "rs2define.h"

typedef struct mondata_tag
{
	long technical_point;		/* Zp_ */
	long hit_point;				/* qbg|Cg */
	int life_point;				/* Ct|Cg */
	int tech_point;				/* Z|Cg */
	int mag_point;				/* p|Cg */
	int level_tech;				/* Zx */
	int level_mag;				/* px */
	int strength;				/* r */
	int dexterity;				/* p */
	int magic_power;			/*  */
	int unknown;				/* s */
	int speed;					/* f */
	int stamina;				/* ̗ */
	int defense_slash;			/* aU̖h */
	int defense_knock;			/* U̖h */
	int defense_poke;			/* ˍU̖h */
	int defense_shoot;			/* ˍU̖h */
	int defense_fire;			/* MU̖h */
	int defense_ice;			/* CU̖h */
	int defense_thunder;		/* U̖h */
	int defense_state;			/* ԕωU̖h */
	int shield_defense_power;	/* ̖h */
	int shield_evade_rate;		/* ̉ */
	elem_t shield_regist_elem;	/* ̖h䑮 */
	state_t regist_state;		/* ԕωւ̑ϐ */
	int flag_frying;			/* ł */
	int flag_boss;				/* {Xł */
	int flag_undead;			/* Afbhnł */
	int flag_woman;				/* ł */
	int flag_target_emperor;	/* cUڕWƂ */
	int flag_target_male;		/* jLN^UڕWƂ */
	int flag_target_female;		/* LN^UڕWƂ */
	int flag_target_hp_low;		/* qbg|CgȂLN^UڕWƂ */
	int flag_target_hp_high;	/* qbg|CgLN^UڕWƂ */
	int flag_target_nouse;		/* gp */
	int type_race;				/* 푰 */
	int type_act_select;		/* 2ނ̍sp^[̂ǂg */
	int type_act;				/* s^Cv */
	int weapon_no[2];			/*  */
	int item_no[2];				/* ACe */
	int action_no[2][8];		/* sp^[ */
} mondata_t;

const char *mon_getname(int index);
mondata_t *mon_readdata(void);
int mon_writeparam(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeregist(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeflag(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeitem(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeequip(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeact(const char *ptr_filename, const mondata_t *ptr_mondata);

#endif /* RS2MONSTER_H */
