/*
 *	rs3define.h
 *		Copyright (C)2002, 2003 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#ifndef RS3DEFINE_H
#define RS3DEFINE_H

enum
{
	ELEM_IDX_STATE,		/* ԕω */
	ELEM_IDX_THUNDER,	/*  */
	ELEM_IDX_ICE,		/* C */
	ELEM_IDX_FIRE,		/* M */
	ELEM_IDX_SHOOT,		/*  */
	ELEM_IDX_POKE,		/*  */
	ELEM_IDX_KNOCK,		/*  */
	ELEM_IDX_SLASH,		/* a */

	NUM_ELEMENT
};

enum
{
	STATE_IDX_STUN,		/* X^ */
	STATE_IDX_POISON,	/* ғ */
	STATE_IDX_MIND,		/* _ */
	STATE_IDX_DARKNESS,	/* È */
	STATE_IDX_SLEEP,	/*  */
	STATE_IDX_PARALYZE,	/*  */
	STATE_IDX_UNKNOWN,	/* s */
	STATE_IDX_DEATH,	/*  */

	NUM_STATE
};

#define ELEM_STATE		(1U << ELEM_IDX_STATE)
#define ELEM_THUNDER	(1U << ELEM_IDX_THUNDER)
#define ELEM_ICE		(1U << ELEM_IDX_ICE)
#define ELEM_FIRE		(1U << ELEM_IDX_FIRE)
#define ELEM_SHOOT		(1U << ELEM_IDX_SHOOT)
#define ELEM_POKE		(1U << ELEM_IDX_POKE)
#define ELEM_KNOCK		(1U << ELEM_IDX_KNOCK)
#define ELEM_SLASH		(1U << ELEM_IDX_SLASH)
#define ELEM_ALL		(ELEM_STATE	| ELEM_THUNDER	| ELEM_ICE		| ELEM_FIRE	| \
						ELEM_SHOOT	| ELEM_POKE		| ELEM_KNOCK	| ELEM_SLASH)

#define STATE_STUN		(1U << STATE_IDX_STUN)
#define STATE_POISON	(1U << STATE_IDX_POISON)
#define STATE_MIND		(1U << STATE_IDX_MIND)
#define STATE_DARKNESS	(1U << STATE_IDX_DARKNESS)
#define STATE_SLEEP		(1U << STATE_IDX_SLEEP)
#define STATE_PARALYZE	(1U << STATE_IDX_PARALYZE)
#define STATE_UNKNOWN	(1U << STATE_IDX_UNKNOWN)
#define STATE_DEATH		(1U << STATE_IDX_DEATH)
#define STATE_ALL		(STATE_STUN		| STATE_POISON		| STATE_MIND		| STATE_DARKNESS	| \
						STATE_SLEEP		| STATE_PARALYZE	| STATE_UNKNOWN		| STATE_DEATH)

typedef unsigned long elem_t;
typedef unsigned long state_t;

const char *str_getflag(int flag);
const char *str_getelem(elem_t elem, int index);
void str_printelem(FILE *stream, elem_t elem, elem_t elem_mask);
const char *str_getstate(state_t state, int index);
void str_printstate(FILE *stream, state_t state, state_t state_mask);
const char *str_getrace(int index);
const char *str_gethealing(int index);

int item_getdefense(int defense, int regist);

#endif /* RS3DEFINE_H */
